// ApplicationLayer.cpp
//
// Author: Mike McCauley (mikem@airspayce.com)
// Copyright (C) 2013 Mike McCauley
// $Id: ApplicationLayer.cpp,v 1.1 2013/07/14 06:32:28 mikem Exp $

#include "ApplicationLayer.h"
#include "NetworkLayer.h"
#include "Log.h"

Map27ApplicationLayer::Map27ApplicationLayer()
{
}

void Map27ApplicationLayer::setNetworkLayer(Map27NetworkLayer* networkLayer)
{
    _networkLayer = networkLayer;
}

Map27NetworkLayer* Map27ApplicationLayer::networkLayer()
{
    return _networkLayer;
}

// Inputs from Application
void Map27ApplicationLayer::power_on()
{
    if (_networkLayer)
	_networkLayer->power_on();
}

void Map27ApplicationLayer::poll()
{
    if (_networkLayer)
	_networkLayer->poll();
}

////////////////////////////////////////////////////////////
// Inputs from Network Layer
void Map27ApplicationLayer::error(uint8_t type)
{
    DEBUG_PRINTF("ApplicationLayer: error %d\n", type);
}

void Map27ApplicationLayer::receiveStatus(Map27Address&, uint8_t status)
{
    DEBUG_PRINTF("ApplicationLayer: receiveStatus\n");
}

void Map27ApplicationLayer::receiveStatusAck(Map27Address& address, uint8_t cause)
{
    DEBUG_PRINTF("ApplicationLayer: receiveStatusAck\n");
}

void Map27ApplicationLayer::receiveCleared(Map27Address& address, uint8_t cause)
{
    DEBUG_PRINTF("ApplicationLayer: receiveCleared\n");
}

void Map27ApplicationLayer::receiveSST(Map27Address& address, uint8_t* buf, uint8_t bufLen)
{
    DEBUG_PRINTF("ApplicationLayer: receiveSST\n");
}

void Map27ApplicationLayer::receiveSSTAck(Map27Address& address, uint8_t cause)
{
    DEBUG_PRINTF("ApplicationLayer: receiveSSTAck\n");
}

void Map27ApplicationLayer::receiveMST(Map27Address& address, uint8_t* buf, uint8_t bufLen)
{
    DEBUG_PRINTF("ApplicationLayer: receiveMST\n");
}

void Map27ApplicationLayer::receiveMSTAck(Map27Address& address, uint8_t cause)
{
    DEBUG_PRINTF("ApplicationLayer: receiveMSTAck\n");
}

void Map27ApplicationLayer::receiveSetupProgress(Map27Address& address, uint8_t cause)
{
    DEBUG_PRINTF("ApplicationLayer: receiveSetupProgress\n");
}

void Map27ApplicationLayer::receiveIncomingVoiceModem(Map27Address& address, uint8_t details, uint8_t* buf, uint8_t bufLen)
{
    DEBUG_PRINTF("ApplicationLayer: receiveIncomingVoiceModem\n");
}

void Map27ApplicationLayer::receiveProgress(Map27Address& address, uint8_t cause)
{
    DEBUG_PRINTF("ApplicationLayer: receiveProgress\n");
}

void Map27ApplicationLayer::receiveModemData(uint8_t* buf, uint8_t bufLen)
{
    DEBUG_PRINTF("ApplicationLayer: receiveModemData\n");
}

void Map27ApplicationLayer::receiveRadioPersonality(Map27Address& address, uint8_t manufacturers_code, uint8_t model, uint32_t serial, uint8_t facilities_a, uint8_t facilities_b, uint8_t facilities_c, uint8_t codings)
{
    DEBUG_PRINTF("ApplicationLayer: receiveRadioPersonality\n");
}

void Map27ApplicationLayer::receiveProtocolInfo(uint8_t reason)
{
    DEBUG_PRINTF("ApplicationLayer: receiveProtocolInfo\n");
}

void Map27ApplicationLayer::receiveNumberingInfo(Map27Address& address, 
			  uint16_t individual_base, bool individual_base_3digit, uint16_t highest_ident, 
			  uint16_t group_base, bool group_base_3digit, uint16_t highest_group)
{
    DEBUG_PRINTF("ApplicationLayer: receiveNumberingInfo\n");
}

void Map27ApplicationLayer::receiveRadioSettings(uint8_t controls_a, uint8_t controls_b, uint8_t controls_c, uint8_t codings)
{
    DEBUG_PRINTF("ApplicationLayer: receiveRadioSettings\n");
}

void Map27ApplicationLayer::receiveOperatingCondition(uint8_t conditions, uint8_t field_strength, uint8_t max_call_duration)
{
    DEBUG_PRINTF("ApplicationLayer: receiveOperatingCondition\n");
}

void Map27ApplicationLayer::receiveNetworkInformation(uint16_t channel, uint16_t sys_ident)
{
    DEBUG_PRINTF("ApplicationLayer: receiveNetworkInformation\n");
}

void Map27ApplicationLayer::receiveRadioTestResult(uint8_t* buf, uint8_t bufLen)
{
    DEBUG_PRINTF("ApplicationLayer: receiveRadioTestResult\n");
}

void Map27ApplicationLayer::link_ready()
{
    DEBUG_PRINTF("ApplicationLayer: link_ready\n");
}

void Map27ApplicationLayer::link_failure()
{
    DEBUG_PRINTF("ApplicationLayer: link_failure\n");
}

void Map27ApplicationLayer::packet_accepted()
{
    DEBUG_PRINTF("ApplicationLayer: packet_accepted\n");
}

void Map27ApplicationLayer::packet_rejected()
{
    DEBUG_PRINTF("ApplicationLayer: packet_rejected\n");
}


