// Timer.cpp

#include "Timer.h"
#include "Log.h"

Map27Timer::Map27Timer()
{
    _active = false;
    _interval = 0;
    _callback = 0;
}

void Map27Timer::stop()
{
    _active = false;
}

void Map27Timer::start()
{
    ::gettimeofday(&_startTime, 0);
    _active = true;
}

void Map27Timer::start(uint32_t interval)
{
    setInterval(interval);
    start();
}

void Map27Timer::poll()
{
    if (_active)
    {
	struct timeval currentTime;
	::gettimeofday(&currentTime, 0);
	// Compute milliseconds difference between start time and now
	uint32_t diff = 
	      ((currentTime.tv_sec  - _startTime.tv_sec)  * 1000) 
	    + ((currentTime.tv_usec - _startTime.tv_usec) / 1000);
	if (diff >= _interval)
	    triggered();
    }
}

void Map27Timer::triggered()
{
//    printf("triggered %x\n", this);
    _active = false; // One shot
    if (_callback)
	(*_callback)(_callbackArg);
}

void Map27Timer::setInterval(uint32_t interval)
{
    _interval = interval;
}

void Map27Timer::setCallback(void (*callback)(void*), void* callbackArg)
{
    _callback = callback;
    _callbackArg = callbackArg;
}

uint32_t Map27Timer::interval()
{
    return _interval;
}

bool Map27Timer::active()
{
    return _active;
}
